Gst::VideoOverlay Class Reference
gstreamermm Interfaces

An interface for setting/getting a Window on elements supporting it. More...

`#include <gstreamermm/videooverlay.h>`

Inherits Interface.

## Public Member Functions

| VideoOverlay (VideoOverlay&& src) noexcept
VideoOverlay& | operator= (VideoOverlay&& src) noexcept
| ~VideoOverlay () noexcept override
GstVideoOverlay* | gobj ()
| Provides access to the underlying C GObject. More...
const GstVideoOverlay* | gobj () const
| Provides access to the underlying C GObject. More...
void | set_window_handle (guintptr window_handle)
| This will call the video overlay's set_window_handle method. More...
void | got_window_handle (guintptr window_handle)
| This will post a "have-window-handle" element message on the bus. More...
void | prepare_window_handle ()
| This will post a "prepare-window-handle" element message on the bus to give applications an opportunity to call gst_video_overlay_set_window_handle() before a plugin creates its own window. More...
void | expose ()
| Tell an overlay that it has been exposed. More...
void | handle_events (bool handle_events)
| Tell an overlay that it should handle events from the window system. More...
bool | set_render_rectangle (int x, int y, int width, int height)
| Configure a subregion as a video target within the window set by gst_video_overlay_set_window_handle(). More...
virtual void | set_window_handle_vfunc (guintptr handle)
| Virtual method to configure the window handle. More...
virtual void | expose_vfunc ()
| Virtual method to handle expose events. More...
virtual void | handle_events_vfunc (bool handle_events)
| Virtual method to handle events. More...
virtual void | set_render_rectangle_vfunc (int x, int y, int width, int height)
| Virtual method to set the render rectangle. More...

## Static Public Member Functions

static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions

| VideoOverlay ()
| You should derive from this class to use it. More...

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr< Gst::VideoOverlay > | wrap (GstVideoOverlay* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

An interface for setting/getting a Window on elements supporting it.

The VideoOverlay interface is used for 2 main purposes :

- To get a grab on the Window where the video sink element is going to render. This is achieved by either being informed about the Window identifier that the video sink element generated, or by forcing the video sink element to use a specific Window identifier for rendering.
- To force a redrawing of the latest video frame the video sink element displayed on the Window. Indeed if the Pipeline is in STATE_PAUSED state, moving the Window around will damage its content. Application developers will want to handle the Expose events themselves and force the video sink element to refresh the Window's content.

Using the Window created by the video sink is probably the simplest scenario, in some cases, though, it might not be flexible enough for application developers if they need to catch events such as mouse moves and button clicks.

Setting a specific Window identifier on the video sink element is the most flexible solution but it has some issues. Indeed the application needs to set its Window identifier at the right time to avoid internal Window creation from the video sink element. To solve this issue a Message is posted on the bus to inform the application that it should set the Window identifier immediately. Here is an example on how to do that correctly:

#include <gdk/gdkx.h>
...
void PlayerWindow::on_bus_message_sync(
const Glib::RefPtr<Gst::Message>& message)
{
// ignore anything but 'prepare-xwindow-id' element messages
if(message->get_message_type() != Gst::MESSAGE_ELEMENT)
return;
if(!message->get_structure().has_name("prepare-xwindow-id"))
return;
Glib::RefPtr<Gst::Element> element =
Glib::RefPtr<Gst::Element>::cast_dynamic(message->get_source());
Glib::RefPtr< Gst::ElementInterfaced<Gst::XOverlay> > xoverlay =
Gst::Interface::cast <Gst::XOverlay>(element);
if(xoverlay)
{
const gulong xWindowId =
GDK_WINDOW_XID(widget->get_window()->gobj());
xoverlay->set_xwindow_id(xWindowId);
}
}
...
int main (int argc, char *argv[])
{
...
// Get the bus from the pipeline:
Glib::RefPtr<Gst::Bus> bus = pipeline->get_bus();
// Enable synchronous message emission:
bus->enable_sync_message_emission();
// Connect to bus's synchronous message signal:
bus->signal_sync_message().connect(
sigc::mem_fun(*this, &PlayerWindow::on_bus_message_sync));
...
}

## Constructor & Destructor Documentation

## VideoOverlay() [1/2]

Gst::VideoOverlay::VideoOverlay | ( |  | ) |

protected

You should derive from this class to use it.

## VideoOverlay() [2/2]

Gst::VideoOverlay::VideoOverlay | ( | VideoOverlay&& | src | ) |

noexcept

## ~VideoOverlay()

Gst::VideoOverlay::~VideoOverlay | ( |  | ) |

override noexcept

## Member Function Documentation

## add_interface()

static void Gst::VideoOverlay::add_interface | ( | GType | gtype_implementer | ) |

static

## expose()

void Gst::VideoOverlay::expose | ( |  | ) |

Tell an overlay that it has been exposed.

This will redraw the current frame in the drawable even if the pipeline is PAUSED.

## expose_vfunc()

virtual void Gst::VideoOverlay::expose_vfunc | ( |  | ) |

virtual

Virtual method to handle expose events.

## get_type()

static GType Gst::VideoOverlay::get_type | ( |  | ) |

static

Get the GType for this class, for use with the underlying GObject type system.

## gobj() [1/2]

GstVideoOverlay* Gst::VideoOverlay::gobj | ( |  | ) |

inline

Provides access to the underlying C GObject.

## gobj() [2/2]

const GstVideoOverlay* Gst::VideoOverlay::gobj | ( |  | ) | const

inline

Provides access to the underlying C GObject.

## got_window_handle()

void Gst::VideoOverlay::got_window_handle | ( | guintptr | window_handle | ) |

This will post a "have-window-handle" element message on the bus.

This function should only be used by video overlay plugin developers.

Parameters

  window_handle | A platform-specific handle referencing the window.

## handle_events()

void Gst::VideoOverlay::handle_events | ( | bool | handle_events | ) |

Tell an overlay that it should handle events from the window system.

These events are forwarded upstream as navigation events. In some window system, events are not propagated in the window hierarchy if a client is listening for them. This method allows you to disable events handling completely from the Gst::VideoOverlay.

Parameters

  handle_events | A `bool` indicating if events should be handled or not.

## handle_events_vfunc()

virtual void Gst::VideoOverlay::handle_events_vfunc | ( | bool | handle_events | ) |

virtual

Virtual method to handle events.

## operator=()

VideoOverlay& Gst::VideoOverlay::operator= | ( | VideoOverlay&& | src | ) |

noexcept

## prepare_window_handle()

void Gst::VideoOverlay::prepare_window_handle | ( |  | ) |

This will post a "prepare-window-handle" element message on the bus to give applications an opportunity to call gst_video_overlay_set_window_handle() before a plugin creates its own window.

This function should only be used by video overlay plugin developers.

## set_render_rectangle()

bool Gst::VideoOverlay::set_render_rectangle | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height
| ) |  |

Configure a subregion as a video target within the window set by gst_video_overlay_set_window_handle().

If this is not used or not supported the video will fill the area of the window set as the overlay to 100%. By specifying the rectangle, the video can be overlayed to a specific region of that window only. After setting the new rectangle one should call gst_video_overlay_expose() to force a redraw. To unset the region pass -1 for the width and height parameters.

This method is needed for non fullscreen video overlay in UI toolkits that do not support subwindows.

Parameters

  x | The horizontal offset of the render area inside the window.
  y | The vertical offset of the render area inside the window.
  width | The width of the render area inside the window.
  height | The height of the render area inside the window.

Returns
  `false` if not supported by the sink.

## set_render_rectangle_vfunc()

virtual void Gst::VideoOverlay::set_render_rectangle_vfunc | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height
| ) |  |

virtual

Virtual method to set the render rectangle.

## set_window_handle()

void Gst::VideoOverlay::set_window_handle | ( | guintptr | window_handle | ) |

This will call the video overlay's set_window_handle method.

You should use this method to tell to an overlay to display video output to a specific window (e.g. an XWindow on X11). Passing 0 as the window_handle will tell the overlay to stop using that window and create an internal one.

Parameters

  window_handle | A handle referencing the window.

## set_window_handle_vfunc()

virtual void Gst::VideoOverlay::set_window_handle_vfunc | ( | guintptr | handle | ) |

virtual

Virtual method to configure the window handle.

## Friends And Related Function Documentation

## wrap()

Glib::RefPtr< Gst::VideoOverlay > wrap | ( | GstVideoOverlay * | object,
|  | bool | take_copy = `false`
| ) |  |

related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.